

# Resources
<a name="resources"></a>

The Amazon MQ REST API includes the following resources.

**Topics**
+ [

# Broker
](brokers-broker-id.md)
+ [

# Broker Engine Types
](broker-engine-types.md)
+ [

# Broker Instance Options
](broker-instance-options.md)
+ [

# Broker Reboot
](brokers-broker-id-reboot.md)
+ [

# Brokers
](brokers.md)
+ [

# Brokers broker-id Promote
](brokers-broker-id-promote.md)
+ [

# Configuration
](configurations-configuration-id.md)
+ [

# Configuration Revision
](configurations-configuration-id-revisions-configuration-revision.md)
+ [

# Configuration Revisions
](configurations-configuration-id-revisions.md)
+ [

# Configurations
](configurations.md)
+ [

# Tag
](tags-resource-arn.md)
+ [

# User
](brokers-broker-id-users-username.md)
+ [

# Users
](brokers-broker-id-users.md)

# Broker
<a name="brokers-broker-id"></a>

A broker is a message broker environment running on Amazon MQ. It is the basic building block of Amazon MQ. For more information about the different components of an Amazon MQ broker, see [How Amazon MQ works](https://docs.aws.amazon.com//amazon-mq/latest/developer-guide/amazon-mq-how-it-works.html) in the *Amazon MQ Developer Guide*.

## URI
<a name="brokers-broker-id-url"></a>

`/v1/brokers/broker-id`

## HTTP methods
<a name="brokers-broker-id-http-methods"></a>

### GET
<a name="brokers-broker-idget"></a>

**Operation ID:** `DescribeBroker`

Returns information about the specified broker.


**Path parameters**  

| Name | Type | Required | Description | 
| --- |--- |--- |--- |
| broker-id | String | True | The unique ID that Amazon MQ generates for the broker. | 


**Responses**  

| Status code | Response model | Description | 
| --- |--- |--- |
| 200 |  DescribeBrokerOutput | HTTP Status Code 200: OK. | 
| 400 | Error | HTTP Status Code 400: Bad request due to incorrect input. Correct your request and then retry it. | 
| 403 | Error | HTTP Status Code 403: Access forbidden. Correct your credentials and then retry your request. | 
| 404 | Error | HTTP Status Code 404: Resource not found due to incorrect input. Correct your request and then retry it. | 
| 500 | Error | HTTP Status Code 500: Unexpected internal server error. Retrying your request might resolve the issue. | 

### PUT
<a name="brokers-broker-idput"></a>

**Operation ID:** `UpdateBroker`

Adds a pending configuration change to a broker.


**Path parameters**  

| Name | Type | Required | Description | 
| --- |--- |--- |--- |
| broker-id | String | True | The unique ID that Amazon MQ generates for the broker. | 


**Responses**  

| Status code | Response model | Description | 
| --- |--- |--- |
| 200 |  UpdateBrokerOutput | HTTP Status Code 200: OK. | 
| 400 | Error | HTTP Status Code 400: Bad request due to incorrect input. Correct your request and then retry it. | 
| 403 | Error | HTTP Status Code 403: Access forbidden. Correct your credentials and then retry your request. | 
| 404 | Error | HTTP Status Code 404: Resource not found due to incorrect input. Correct your request and then retry it. | 
| 409 | Error | HTTP Status Code 409: Configuration ID is already in use. Remove the configuration from all brokers and retry the request. | 
| 500 | Error | HTTP Status Code 500: Unexpected internal server error. Retrying your request might resolve the issue. | 

### DELETE
<a name="brokers-broker-iddelete"></a>

**Operation ID:** `DeleteBroker`

Deletes a broker. Note: This API is asynchronous.


**Path parameters**  

| Name | Type | Required | Description | 
| --- |--- |--- |--- |
| broker-id | String | True | The unique ID that Amazon MQ generates for the broker. | 


**Responses**  

| Status code | Response model | Description | 
| --- |--- |--- |
| 200 |  DeleteBrokerOutput | HTTP Status Code 200: OK. | 
| 400 | Error | HTTP Status Code 400: Bad request due to incorrect input. Correct your request and then retry it. | 
| 403 | Error | HTTP Status Code 403: Access forbidden. Correct your credentials and then retry your request. | 
| 404 | Error | HTTP Status Code 404: Resource not found due to incorrect input. Correct your request and then retry it. | 
| 500 | Error | HTTP Status Code 500: Unexpected internal server error. Retrying your request might resolve the issue. | 

### OPTIONS
<a name="brokers-broker-idoptions"></a>


**Path parameters**  

| Name | Type | Required | Description | 
| --- |--- |--- |--- |
| broker-id | String | True | The unique ID that Amazon MQ generates for the broker. | 


**Responses**  

| Status code | Response model | Description | 
| --- |--- |--- |
| 200 | None | Default response for CORS method | 

## Schemas
<a name="brokers-broker-id-schemas"></a>

### Request bodies
<a name="brokers-broker-id-request-examples"></a>

#### PUT schema
<a name="brokers-broker-id-request-body-put-example"></a>

```
{
  "dataReplicationMode": enum,
  "engineVersion": "string",
  "maintenanceWindowStartTime": {
    "dayOfWeek": enum,
    "timeZone": "string",
    "timeOfDay": "string"
  },
  "configuration": {
    "id": "string",
    "revision": integer
  },
  "storageConfiguration": {
    "efs": {
      "throughputMode": enum
    }
  },
  "authenticationStrategy": enum,
  "securityGroups": [
    "string"
  ],
  "ldapServerMetadata": {
    "roleSearchMatching": "string",
    "serviceAccountPassword": "string",
    "roleBase": "string",
    "hosts": [
      "string"
    ],
    "roleName": "string",
    "userBase": "string",
    "roleSearchSubtree": boolean,
    "serviceAccountUsername": "string",
    "userRoleName": "string",
    "userSearchMatching": "string",
    "userSearchSubtree": boolean
  },
  "logs": {
    "general": boolean,
    "audit": boolean
  },
  "hostInstanceType": "string",
  "autoMinorVersionUpgrade": boolean
}
```

### Response bodies
<a name="brokers-broker-id-response-examples"></a>

#### DescribeBrokerOutput schema
<a name="brokers-broker-id-response-body-describebrokeroutput-example"></a>

```
{
  "pendingEngineVersion": "string",
  "pendingAuthenticationStrategy": enum,
  "pendingSecurityGroups": [
    "string"
  ],
  "configurations": {
    "current": {
      "id": "string",
      "revision": integer
    },
    "pending": {
      "id": "string",
      "revision": integer
    },
    "history": [
      {
        "id": "string",
        "revision": integer
      }
    ]
  },
  "brokerState": enum,
  "pendingDataReplicationMode": enum,
  "engineType": enum,
  "brokerInstances": [
    {
      "endpoints": [
        "string"
      ],
      "consoleURL": "string",
      "ipAddress": "string"
    }
  ],
  "hostInstanceType": "string",
  "dataReplicationMode": enum,
  "storageConfiguration": {
    "efs": {
      "throughputMode": enum
    }
  },
  "publiclyAccessible": boolean,
  "logs": {
    "generalLogGroup": "string",
    "general": boolean,
    "audit": boolean,
    "pending": {
      "general": boolean,
      "audit": boolean
    },
    "auditLogGroup": "string"
  },
  "ldapServerMetadata": {
    "roleSearchMatching": "string",
    "roleBase": "string",
    "hosts": [
      "string"
    ],
    "roleName": "string",
    "userBase": "string",
    "roleSearchSubtree": boolean,
    "serviceAccountUsername": "string",
    "userRoleName": "string",
    "userSearchMatching": "string",
    "userSearchSubtree": boolean
  },
  "subnetIds": [
    "string"
  ],
  "pendingHostInstanceType": "string",
  "engineVersion": "string",
  "brokerArn": "string",
  "brokerId": "string",
  "deploymentMode": enum,
  "maintenanceWindowStartTime": {
    "dayOfWeek": enum,
    "timeZone": "string",
    "timeOfDay": "string"
  },
  "created": "string",
  "authenticationStrategy": enum,
  "users": [
    {
      "pendingChange": enum,
      "username": "string"
    }
  ],
  "pendingStorageConfiguration": {
    "efs": {
      "throughputMode": enum
    }
  },
  "tags": {
  },
  "dataReplicationMetadata": {
    "dataReplicationCounterpart": {
      "brokerId": "string",
      "region": "string"
    },
    "dataReplicationRole": "string"
  },
  "pendingLdapServerMetadata": {
    "roleSearchMatching": "string",
    "roleBase": "string",
    "hosts": [
      "string"
    ],
    "roleName": "string",
    "userBase": "string",
    "roleSearchSubtree": boolean,
    "serviceAccountUsername": "string",
    "userRoleName": "string",
    "userSearchMatching": "string",
    "userSearchSubtree": boolean
  },
  "encryptionOptions": {
    "useAwsOwnedKey": boolean,
    "kmsKeyId": "string"
  },
  "pendingDataReplicationMetadata": {
    "dataReplicationCounterpart": {
      "brokerId": "string",
      "region": "string"
    },
    "dataReplicationRole": "string"
  },
  "storageType": enum,
  "actionsRequired": [
    {
      "actionRequiredCode": "string",
      "actionRequiredInfo": "string"
    }
  ],
  "securityGroups": [
    "string"
  ],
  "brokerName": "string",
  "autoMinorVersionUpgrade": boolean
}
```

#### UpdateBrokerOutput schema
<a name="brokers-broker-id-response-body-updatebrokeroutput-example"></a>

```
{
  "engineVersion": "string",
  "brokerId": "string",
  "maintenanceWindowStartTime": {
    "dayOfWeek": enum,
    "timeZone": "string",
    "timeOfDay": "string"
  },
  "configuration": {
    "id": "string",
    "revision": integer
  },
  "authenticationStrategy": enum,
  "pendingDataReplicationMode": enum,
  "hostInstanceType": "string",
  "pendingStorageConfiguration": {
    "efs": {
      "throughputMode": enum
    }
  },
  "dataReplicationMode": enum,
  "dataReplicationMetadata": {
    "dataReplicationCounterpart": {
      "brokerId": "string",
      "region": "string"
    },
    "dataReplicationRole": "string"
  },
  "pendingDataReplicationMetadata": {
    "dataReplicationCounterpart": {
      "brokerId": "string",
      "region": "string"
    },
    "dataReplicationRole": "string"
  },
  "securityGroups": [
    "string"
  ],
  "logs": {
    "general": boolean,
    "audit": boolean
  },
  "ldapServerMetadata": {
    "roleSearchMatching": "string",
    "roleBase": "string",
    "hosts": [
      "string"
    ],
    "roleName": "string",
    "userBase": "string",
    "roleSearchSubtree": boolean,
    "serviceAccountUsername": "string",
    "userRoleName": "string",
    "userSearchMatching": "string",
    "userSearchSubtree": boolean
  },
  "autoMinorVersionUpgrade": boolean
}
```

#### DeleteBrokerOutput schema
<a name="brokers-broker-id-response-body-deletebrokeroutput-example"></a>

```
{
  "brokerId": "string"
}
```

#### Error schema
<a name="brokers-broker-id-response-body-error-example"></a>

```
{
  "errorAttribute": "string",
  "message": "string"
}
```

## Properties
<a name="brokers-broker-id-properties"></a>

### ActionRequired
<a name="brokers-broker-id-model-actionrequired"></a>

Action required for a broker.


| Property | Type | Required | Description | 
| --- |--- |--- |--- |
| actionRequiredCode | string | False | The code you can use to find instructions on the action required to resolve your broker issue. | 
| actionRequiredInfo | string | False | Information about the action required to resolve your broker issue. | 

### AuthenticationStrategy
<a name="brokers-broker-id-model-authenticationstrategy"></a>

Optional. The authentication strategy used to secure the broker. The default is `SIMPLE`.
+ `SIMPLE`
+ `LDAP`
+ `CONFIG_MANAGED`

### BrokerInstance
<a name="brokers-broker-id-model-brokerinstance"></a>

Returns information about all brokers.


| Property | Type | Required | Description | 
| --- |--- |--- |--- |
| consoleURL | string | False | The brokers web console URL. | 
| endpoints | Array of type string | False | The broker's wire-level protocol endpoints. | 
| ipAddress | string | False | The IP address of the Elastic Network Interface (ENI) attached to the broker. Does not apply to RabbitMQ brokers. | 

### BrokerState
<a name="brokers-broker-id-model-brokerstate"></a>

The broker's status.
+ `CREATION_IN_PROGRESS`
+ `CREATION_FAILED`
+ `DELETION_IN_PROGRESS`
+ `RUNNING`
+ `REBOOT_IN_PROGRESS`
+ `CRITICAL_ACTION_REQUIRED`
+ `REPLICA`

### BrokerStorageConfiguration
<a name="brokers-broker-id-model-brokerstorageconfiguration"></a>

The storage configurations of a broker.


| Property | Type | Required | Description | 
| --- |--- |--- |--- |
| efs | [EfsBrokerStorageConfiguration](#brokers-broker-id-model-efsbrokerstorageconfiguration) | False |  | 

### BrokerStorageType
<a name="brokers-broker-id-model-brokerstoragetype"></a>

The broker's storage type.

**Important**  
 `EFS` is not supported for RabbitMQ engine type.
+ `EBS`
+ `EFS`

### ChangeType
<a name="brokers-broker-id-model-changetype"></a>

The type of change pending for the ActiveMQ user.
+ `CREATE`
+ `UPDATE`
+ `DELETE`

### ConfigurationId
<a name="brokers-broker-id-model-configurationid"></a>

A list of information about the configuration.


| Property | Type | Required | Description | 
| --- |--- |--- |--- |
| id | string | True | Required. The unique ID that Amazon MQ generates for the configuration. | 
| revision | integer | False | The revision number of the configuration. | 

### Configurations
<a name="brokers-broker-id-model-configurations"></a>

Broker configuration information


| Property | Type | Required | Description | 
| --- |--- |--- |--- |
| current | [ConfigurationId](#brokers-broker-id-model-configurationid) | False | The broker's current configuration. | 
| history | Array of type [ConfigurationId](#brokers-broker-id-model-configurationid) | False | The history of configurations applied to the broker. | 
| pending | [ConfigurationId](#brokers-broker-id-model-configurationid) | False | The broker's pending configuration. | 

### DataReplicationCounterpart
<a name="brokers-broker-id-model-datareplicationcounterpart"></a>

Specifies a broker in a data replication pair.


| Property | Type | Required | Description | 
| --- |--- |--- |--- |
| brokerId | string | True | Required. The unique broker id generated by Amazon MQ. | 
| region | string | True | Required. The region of the broker. | 

### DataReplicationMetadataOutput
<a name="brokers-broker-id-model-datareplicationmetadataoutput"></a>

The replication details of the data replication-enabled broker. Only returned if dataReplicationMode or pendingDataReplicationMode is set to CRDR.


| Property | Type | Required | Description | 
| --- |--- |--- |--- |
| dataReplicationCounterpart | [DataReplicationCounterpart](#brokers-broker-id-model-datareplicationcounterpart) | False | Describes the replica/primary broker. Only returned if this broker is currently set as a primary or replica in the broker's dataReplicationRole property. | 
| dataReplicationRole | string | True | Defines the role of this broker in a data replication pair. When a replica broker is promoted to primary, this role is interchanged. | 

### DataReplicationMode
<a name="brokers-broker-id-model-datareplicationmode"></a>

Specifies whether a broker is a part of a data replication pair.
+ `NONE`
+ `CRDR`

### DeleteBrokerOutput
<a name="brokers-broker-id-model-deletebrokeroutput"></a>

Returns information about the deleted broker.


| Property | Type | Required | Description | 
| --- |--- |--- |--- |
| brokerId | string | False | The unique ID that Amazon MQ generates for the broker. | 

### DeploymentMode
<a name="brokers-broker-id-model-deploymentmode"></a>

The broker's deployment mode.
+ `SINGLE_INSTANCE`
+ `ACTIVE_STANDBY_MULTI_AZ`
+ `CLUSTER_MULTI_AZ`

### DescribeBrokerOutput
<a name="brokers-broker-id-model-describebrokeroutput"></a>

Returns information about the specified broker.


| Property | Type | Required | Description | 
| --- |--- |--- |--- |
| actionsRequired | Array of type [ActionRequired](#brokers-broker-id-model-actionrequired) | False | Actions required for a broker. | 
| authenticationStrategy | [AuthenticationStrategy](#brokers-broker-id-model-authenticationstrategy) | False | The authentication strategy used to secure the broker. The default is `SIMPLE`. | 
| autoMinorVersionUpgrade | boolean | True | Enables automatic upgrades to new patch versions for brokers as new versions are released and supported by Amazon MQ. Automatic upgrades occur during the scheduled maintenance window or after a manual broker reboot. | 
| brokerArn | string | False | The broker's Amazon Resource Name (ARN). | 
| brokerId | string | False | The unique ID that Amazon MQ generates for the broker. | 
| brokerInstances | Array of type [BrokerInstance](#brokers-broker-id-model-brokerinstance) | False | A list of information about allocated brokers. | 
| brokerName | string | False | The broker's name. This value must be unique in your AWS account account, 1-50 characters long, must contain only letters, numbers, dashes, and underscores, and must not contain white spaces, brackets, wildcard characters, or special characters. | 
| brokerState | [BrokerState](#brokers-broker-id-model-brokerstate) | False | The broker's status. | 
| configurations | [Configurations](#brokers-broker-id-model-configurations) | False | The list of all revisions for the specified configuration. | 
| created | stringFormat: date-time | False | The time when the broker was created. | 
| dataReplicationMetadata | [DataReplicationMetadataOutput](#brokers-broker-id-model-datareplicationmetadataoutput) | False | The replication details of the data replication-enabled broker. Only returned if dataReplicationMode is set to CRDR. | 
| dataReplicationMode | [DataReplicationMode](#brokers-broker-id-model-datareplicationmode) | False | Describes whether this broker is a part of a data replication pair. | 
| deploymentMode | [DeploymentMode](#brokers-broker-id-model-deploymentmode) | True | The broker's deployment mode. | 
| encryptionOptions | [EncryptionOptions](#brokers-broker-id-model-encryptionoptions) | False | Encryption options for the broker. | 
| engineType | [EngineType](#brokers-broker-id-model-enginetype) | True | The type of broker engine. Currently, Amazon MQ supports `ACTIVEMQ` and `RABBITMQ`. | 
| engineVersion | string | False | The broker engine version. For more information, see the [ActiveMQ version management](https://docs.aws.amazon.com//amazon-mq/latest/developer-guide/activemq-version-management.html) and the [RabbitMQ version management](https://docs.aws.amazon.com//amazon-mq/latest/developer-guide/rabbitmq-version-management.html) sections in the Amazon MQ Developer Guide. | 
| hostInstanceType | string | False | The broker's instance type. | 
| ldapServerMetadata | [LdapServerMetadataOutput](#brokers-broker-id-model-ldapservermetadataoutput) | False | The metadata of the LDAP server used to authenticate and authorize connections to the broker. | 
| logs | [LogsSummary](#brokers-broker-id-model-logssummary) | False | The list of information about logs currently enabled and pending to be deployed for the specified broker. | 
| maintenanceWindowStartTime | [WeeklyStartTime](#brokers-broker-id-model-weeklystarttime) | False | The parameters that determine the WeeklyStartTime. | 
| pendingAuthenticationStrategy | [AuthenticationStrategy](#brokers-broker-id-model-authenticationstrategy) | False | The authentication strategy that will be applied when the broker is rebooted. The default is `SIMPLE`. | 
| pendingDataReplicationMetadata | [DataReplicationMetadataOutput](#brokers-broker-id-model-datareplicationmetadataoutput) | False | The pending replication details of the data replication-enabled broker. Only returned if pendingDataReplicationMode is set to CRDR. | 
| pendingDataReplicationMode | [DataReplicationMode](#brokers-broker-id-model-datareplicationmode) | False | Describes whether this broker will be a part of a data replication pair after reboot. | 
| pendingEngineVersion | string | False | The broker engine version to upgrade to. For more information, see the [ActiveMQ version management](https://docs.aws.amazon.com//amazon-mq/latest/developer-guide/activemq-version-management.html) and the [RabbitMQ version management](https://docs.aws.amazon.com//amazon-mq/latest/developer-guide/rabbitmq-version-management.html) sections in the Amazon MQ Developer Guide. | 
| pendingHostInstanceType | string | False | The broker's host instance type to upgrade to. For a list of supported instance types, see [Broker instance types](https://docs.aws.amazon.com//amazon-mq/latest/developer-guide/broker-instance-types). | 
| pendingLdapServerMetadata | [LdapServerMetadataOutput](#brokers-broker-id-model-ldapservermetadataoutput) | False | The metadata of the LDAP server that will be used to authenticate and authorize connections to the broker after it is rebooted. | 
| pendingSecurityGroups | Array of type string | False | The list of pending security groups to authorize connections to brokers. | 
| pendingStorageConfiguration | [BrokerStorageConfiguration](#brokers-broker-id-model-brokerstorageconfiguration) | False | The pending broker's storage configuration. | 
| publiclyAccessible | boolean | True | Enables connections from applications outside of the VPC that hosts the broker's subnets. | 
| securityGroups | Array of type string | False | The list of rules (1 minimum, 125 maximum) that authorize connections to brokers. | 
| storageConfiguration | [BrokerStorageConfiguration](#brokers-broker-id-model-brokerstorageconfiguration) | False | The broker's storage configuration. | 
| storageType | [BrokerStorageType](#brokers-broker-id-model-brokerstoragetype) | False | The broker's storage type. | 
| subnetIds | Array of type string | False | The list of groups that define which subnets and IP ranges the broker can use from different Availability Zones. | 
| tags | object | False | The list of all tags associated with this broker. | 
| users | Array of type [UserSummary](#brokers-broker-id-model-usersummary) | False | The list of all broker usernames for the specified broker. | 

### EfsBrokerStorageConfiguration
<a name="brokers-broker-id-model-efsbrokerstorageconfiguration"></a>

The storage configuration of an EFS broker storage


| Property | Type | Required | Description | 
| --- |--- |--- |--- |
| throughputMode | stringValues: `ELASTIC \| STANDARD` | False | Throughput mode of EFS broker storage | 

### EncryptionOptions
<a name="brokers-broker-id-model-encryptionoptions"></a>

Encryption options for the broker.


| Property | Type | Required | Description | 
| --- |--- |--- |--- |
| kmsKeyId | string | False | The customer master key (CMK) to use for the A AWS KMS (KMS). This key is used to encrypt your data at rest. If not provided, Amazon MQ will use a default CMK to encrypt your data. | 
| useAwsOwnedKey | boolean | True | Enables the use of an AWS owned CMK using AWS KMS (KMS). Set to `true` by default, if no value is provided, for example, for RabbitMQ brokers. | 

### EngineType
<a name="brokers-broker-id-model-enginetype"></a>

The type of broker engine. Amazon MQ supports ActiveMQ and RabbitMQ.
+ `ACTIVEMQ`
+ `RABBITMQ`

### Error
<a name="brokers-broker-id-model-error"></a>

Returns information about an error.


| Property | Type | Required | Description | 
| --- |--- |--- |--- |
| errorAttribute | string | False | The attribute which caused the error. | 
| message | string | False | The explanation of the error. | 

### LdapServerMetadataInput
<a name="brokers-broker-id-model-ldapservermetadatainput"></a>

Optional. The metadata of the LDAP server used to authenticate and authorize connections to the broker.

**Important**  
Does not apply to RabbitMQ brokers.


| Property | Type | Required | Description | 
| --- |--- |--- |--- |
| hosts | Array of type string | True | Specifies the location of the LDAP server such as AWS Directory Service for Microsoft Active Directory. Optional failover server. | 
| roleBase | string | True | The distinguished name of the node in the directory information tree (DIT) to search for roles or groups. For example, `ou=group, ou=corp, dc=corp, dc=example, dc=com`. | 
| roleName | string | False | Specifies the LDAP attribute that identifies the group name attribute in the object returned from the group membership query. | 
| roleSearchMatching | string | True | The LDAP search filter used to find roles within the `roleBase`. The distinguished name of the user matched by `userSearchMatching` is substituted into the `{0}` placeholder in the search filter. The client's username is substituted into the `{1}` placeholder. For example, if you set this option to `(member=uid={1})`for the user `janedoe`, the search filter becomes `(member=uid=janedoe)` after string substitution. It matches all role entries that have a member attribute equal to `uid=janedoe` under the subtree selected by the `roleBase`. | 
| roleSearchSubtree | boolean | False | The directory search scope for the role. If set to true, scope is to search the entire subtree. | 
| serviceAccountPassword | string | True | Service account password. A service account is an account in your LDAP server that has access to initiate a connection. For example, `cn=admin,dc=corp, dc=example, dc=com`. | 
| serviceAccountUsername | string | True | Service account username. A service account is an account in your LDAP server that has access to initiate a connection. For example, `cn=admin,dc=corp, dc=example, dc=com`. | 
| userBase | string | True | Select a particular subtree of the directory information tree (DIT) to search for user entries. The subtree is specified by a DN, which specifies the base node of the subtree. For example, by setting this option to `ou=Users,ou=corp, dc=corp, dc=example, dc=com`, the search for user entries is restricted to the subtree beneath `ou=Users, ou=corp, dc=corp, dc=example, dc=com`. | 
| userRoleName | string | False | Specifies the name of the LDAP attribute for the user group membership. | 
| userSearchMatching | string | True | The LDAP search filter used to find users within the `userBase`. The client's username is substituted into the `{0}` placeholder in the search filter. For example, if this option is set to `(uid={0})` and the received username is `janedoe`, the search filter becomes `(uid=janedoe)` after string substitution. It will result in matching an entry like `uid=janedoe, ou=Users,ou=corp, dc=corp, dc=example, dc=com`. | 
| userSearchSubtree | boolean | False | The directory search scope for the user. If set to true, scope is to search the entire subtree. | 

### LdapServerMetadataOutput
<a name="brokers-broker-id-model-ldapservermetadataoutput"></a>

Optional. The metadata of the LDAP server used to authenticate and authorize connections to the broker.


| Property | Type | Required | Description | 
| --- |--- |--- |--- |
| hosts | Array of type string | True | Specifies the location of the LDAP server such as AWS Directory Service for Microsoft Active Directory. Optional failover server. | 
| roleBase | string | True | The distinguished name of the node in the directory information tree (DIT) to search for roles or groups. For example, `ou=group, ou=corp, dc=corp, dc=example, dc=com`. | 
| roleName | string | False | Specifies the LDAP attribute that identifies the group name attribute in the object returned from the group membership query. | 
| roleSearchMatching | string | True | The LDAP search filter used to find roles within the `roleBase`. The distinguished name of the user matched by `userSearchMatching` is substituted into the `{0}` placeholder in the search filter. The client's username is substituted into the `{1}` placeholder. For example, if you set this option to `(member=uid={1})`for the user `janedoe`, the search filter becomes `(member=uid=janedoe)` after string substitution. It matches all role entries that have a member attribute equal to `uid=janedoe` under the subtree selected by the `roleBase`. | 
| roleSearchSubtree | boolean | False | The directory search scope for the role. If set to true, scope is to search the entire subtree. | 
| serviceAccountUsername | string | True | Service account username. A service account is an account in your LDAP server that has access to initiate a connection. For example, `cn=admin,dc=corp, dc=example, dc=com`. | 
| userBase | string | True | Select a particular subtree of the directory information tree (DIT) to search for user entries. The subtree is specified by a DN, which specifies the base node of the subtree. For example, by setting this option to `ou=Users,ou=corp, dc=corp, dc=example, dc=com`, the search for user entries is restricted to the subtree beneath `ou=Users, ou=corp, dc=corp, dc=example, dc=com`. | 
| userRoleName | string | False | Specifies the name of the LDAP attribute for the user group membership. | 
| userSearchMatching | string | True | The LDAP search filter used to find users within the `userBase`. The client's username is substituted into the `{0}` placeholder in the search filter. For example, if this option is set to `(uid={0})` and the received username is `janedoe`, the search filter becomes `(uid=janedoe)` after string substitution. It will result in matching an entry like `uid=janedoe, ou=Users,ou=corp, dc=corp, dc=example, dc=com`. | 
| userSearchSubtree | boolean | False | The directory search scope for the user. If set to true, scope is to search the entire subtree. | 

### Logs
<a name="brokers-broker-id-model-logs"></a>

The list of information about logs to be enabled for the specified broker.


| Property | Type | Required | Description | 
| --- |--- |--- |--- |
| audit | boolean | False | Enables audit logging. Every user management action made using JMX or the ActiveMQ Web Console is logged. Does not apply to RabbitMQ brokers. | 
| general | boolean | False | Enables general logging. | 

### LogsSummary
<a name="brokers-broker-id-model-logssummary"></a>

The list of information about logs currently enabled and pending to be deployed for the specified broker.


| Property | Type | Required | Description | 
| --- |--- |--- |--- |
| audit | boolean | False | Enables audit logging. Every user management action made using JMX or the ActiveMQ Web Console is logged. | 
| auditLogGroup | string | False | The location of the CloudWatch Logs log group where audit logs are sent. | 
| general | boolean | True | Enables general logging. | 
| generalLogGroup | string | True | The location of the CloudWatch Logs log group where general logs are sent. | 
| pending | [PendingLogs](#brokers-broker-id-model-pendinglogs) | False | The list of information about logs pending to be deployed for the specified broker. | 

### PendingLogs
<a name="brokers-broker-id-model-pendinglogs"></a>

The list of information about logs to be enabled for the specified broker.


| Property | Type | Required | Description | 
| --- |--- |--- |--- |
| audit | boolean | False | Enables audit logging. Every user management action made using JMX or the ActiveMQ Web Console is logged. | 
| general | boolean | False | Enables general logging. | 

### UpdateBrokerInput
<a name="brokers-broker-id-model-updatebrokerinput"></a>

Updates the broker using the specified properties.


| Property | Type | Required | Description | 
| --- |--- |--- |--- |
| authenticationStrategy | [AuthenticationStrategy](#brokers-broker-id-model-authenticationstrategy) | False | Optional. The authentication strategy used to secure the broker. The default is `SIMPLE`. | 
| autoMinorVersionUpgrade | boolean | False | Enables automatic upgrades to new patch versions for brokers as new versions are released and supported by Amazon MQ. Automatic upgrades occur during the scheduled maintenance window or after a manual broker reboot.Must be set to `true` for ActiveMQ brokers version 5.18 and above and for RabbitMQ brokers version 3.13 and above. | 
| configuration | [ConfigurationId](#brokers-broker-id-model-configurationid) | False | A list of information about the configuration. | 
| dataReplicationMode | [DataReplicationMode](#brokers-broker-id-model-datareplicationmode) | False | Defines whether this broker is a part of a data replication pair. | 
| engineVersion | string | False | The broker engine version. For more information, see the [ActiveMQ version management](https://docs.aws.amazon.com//amazon-mq/latest/developer-guide/activemq-version-management.html) and the [RabbitMQ version management](https://docs.aws.amazon.com//amazon-mq/latest/developer-guide/rabbitmq-version-management.html) sections in the Amazon MQ Developer Guide.When upgrading to ActiveMQ version 5.18 and above or RabbitMQ version 3.13 and above, you must have `autoMinorVersionUpgrade` set to `true` for the broker. | 
| hostInstanceType | string | False | The broker's host instance type to upgrade to. For a list of supported instance types, see [Broker instance types](https://docs.aws.amazon.com//amazon-mq/latest/developer-guide/broker-instance-types). | 
| ldapServerMetadata | [LdapServerMetadataInput](#brokers-broker-id-model-ldapservermetadatainput) | False | Optional. The metadata of the LDAP server used to authenticate and authorize connections to the broker. Does not apply to RabbitMQ brokers. | 
| logs | [Logs](#brokers-broker-id-model-logs) | False | Enables Amazon CloudWatch logging for brokers. | 
| maintenanceWindowStartTime | [WeeklyStartTime](#brokers-broker-id-model-weeklystarttime) | False | The parameters that determine the WeeklyStartTime. | 
| securityGroups | Array of type string | False | The list of security groups (1 minimum, 5 maximum) that authorizes connections to brokers. | 
| storageConfiguration | [BrokerStorageConfiguration](#brokers-broker-id-model-brokerstorageconfiguration) | False | The broker's storage configuration. | 

### UpdateBrokerOutput
<a name="brokers-broker-id-model-updatebrokeroutput"></a>

Returns information about the updated broker.


| Property | Type | Required | Description | 
| --- |--- |--- |--- |
| authenticationStrategy | [AuthenticationStrategy](#brokers-broker-id-model-authenticationstrategy) | False | Optional. The authentication strategy used to secure the broker. The default is `SIMPLE`. | 
| autoMinorVersionUpgrade | boolean | False | Enables automatic upgrades to new patch versions for brokers as new versions are released and supported by Amazon MQ. Automatic upgrades occur during the scheduled maintenance window or after a manual broker reboot. | 
| brokerId | string | True | Required. The unique ID that Amazon MQ generates for the broker. | 
| configuration | [ConfigurationId](#brokers-broker-id-model-configurationid) | False | The ID of the updated configuration. | 
| dataReplicationMetadata | [DataReplicationMetadataOutput](#brokers-broker-id-model-datareplicationmetadataoutput) | False | The replication details of the data replication-enabled broker. Only returned if dataReplicationMode is set to CRDR. | 
| dataReplicationMode | [DataReplicationMode](#brokers-broker-id-model-datareplicationmode) | False | Describes whether this broker is a part of a data replication pair. | 
| engineVersion | string | False | The broker engine version to upgrade to. For more information, see the [ActiveMQ version management](https://docs.aws.amazon.com//amazon-mq/latest/developer-guide/activemq-version-management.html) and the [RabbitMQ version management](https://docs.aws.amazon.com//amazon-mq/latest/developer-guide/rabbitmq-version-management.html) sections in the Amazon MQ Developer Guide. | 
| hostInstanceType | string | False | The broker's host instance type to upgrade to. For a list of supported instance types, see [Broker instance types](https://docs.aws.amazon.com//amazon-mq/latest/developer-guide/broker-instance-types). | 
| ldapServerMetadata | [LdapServerMetadataOutput](#brokers-broker-id-model-ldapservermetadataoutput) | False | Optional. The metadata of the LDAP server used to authenticate and authorize connections to the broker. Does not apply to RabbitMQ brokers. | 
| logs | [Logs](#brokers-broker-id-model-logs) | False | The list of information about logs to be enabled for the specified broker. | 
| maintenanceWindowStartTime | [WeeklyStartTime](#brokers-broker-id-model-weeklystarttime) | False | The parameters that determine the WeeklyStartTime. | 
| pendingDataReplicationMetadata | [DataReplicationMetadataOutput](#brokers-broker-id-model-datareplicationmetadataoutput) | False | The pending replication details of the data replication-enabled broker. Only returned if pendingDataReplicationMode is set to CRDR. | 
| pendingDataReplicationMode | [DataReplicationMode](#brokers-broker-id-model-datareplicationmode) | False | Describes whether this broker will be a part of a data replication pair after reboot. | 
| pendingStorageConfiguration | [BrokerStorageConfiguration](#brokers-broker-id-model-brokerstorageconfiguration) | False | The pending broker's storage configuration. | 
| securityGroups | Array of type string | False | The list of security groups (1 minimum, 5 maximum) that authorizes connections to brokers. | 

### UserSummary
<a name="brokers-broker-id-model-usersummary"></a>

Returns a list of all broker users. Does not apply to RabbitMQ brokers.


| Property | Type | Required | Description | 
| --- |--- |--- |--- |
| pendingChange | [ChangeType](#brokers-broker-id-model-changetype) | False | The type of change pending for the broker user. | 
| username | string | True | Required. The username of the broker user. This value can contain only alphanumeric characters, dashes, periods, underscores, and tildes (- . \$1 \$1). This value must be 2-100 characters long. | 

### WeeklyStartTime
<a name="brokers-broker-id-model-weeklystarttime"></a>

The scheduled time period relative to UTC during which Amazon MQ begins to apply pending updates or patches to the broker.


| Property | Type | Required | Description | 
| --- |--- |--- |--- |
| dayOfWeek | stringValues: `MONDAY \| TUESDAY \| WEDNESDAY \| THURSDAY \| FRIDAY \| SATURDAY \| SUNDAY` | True | Required. The day of the week. | 
| timeOfDay | string | True | Required. The time, in 24-hour format. | 
| timeZone | string | False | The time zone, UTC by default, in either the Country/City format, or the UTC offset format. | 

## See also
<a name="brokers-broker-id-see-also"></a>

For more information about using this API in one of the language-specific AWS SDKs and references, see the following:

### DescribeBroker
<a name="DescribeBroker-see-also"></a>
+ [AWS Command Line Interface V2](/goto/cli2/mq-2017-11-27/DescribeBroker)
+ [AWS SDK for .NET V4](/goto/DotNetSDKV4/mq-2017-11-27/DescribeBroker)
+ [AWS SDK for C\$1\$1](/goto/SdkForCpp/mq-2017-11-27/DescribeBroker)
+ [AWS SDK for Go v2](/goto/SdkForGoV2/mq-2017-11-27/DescribeBroker)
+ [AWS SDK for Java V2](/goto/SdkForJavaV2/mq-2017-11-27/DescribeBroker)
+ [AWS SDK for JavaScript V3](/goto/SdkForJavaScriptV3/mq-2017-11-27/DescribeBroker)
+ [AWS SDK for Kotlin](/goto/SdkForKotlin/mq-2017-11-27/DescribeBroker)
+ [AWS SDK for PHP V3](/goto/SdkForPHPV3/mq-2017-11-27/DescribeBroker)
+ [AWS SDK for Python](/goto/boto3/mq-2017-11-27/DescribeBroker)
+ [AWS SDK for Ruby V3](/goto/SdkForRubyV3/mq-2017-11-27/DescribeBroker)

### UpdateBroker
<a name="UpdateBroker-see-also"></a>
+ [AWS Command Line Interface V2](/goto/cli2/mq-2017-11-27/UpdateBroker)
+ [AWS SDK for .NET V4](/goto/DotNetSDKV4/mq-2017-11-27/UpdateBroker)
+ [AWS SDK for C\$1\$1](/goto/SdkForCpp/mq-2017-11-27/UpdateBroker)
+ [AWS SDK for Go v2](/goto/SdkForGoV2/mq-2017-11-27/UpdateBroker)
+ [AWS SDK for Java V2](/goto/SdkForJavaV2/mq-2017-11-27/UpdateBroker)
+ [AWS SDK for JavaScript V3](/goto/SdkForJavaScriptV3/mq-2017-11-27/UpdateBroker)
+ [AWS SDK for Kotlin](/goto/SdkForKotlin/mq-2017-11-27/UpdateBroker)
+ [AWS SDK for PHP V3](/goto/SdkForPHPV3/mq-2017-11-27/UpdateBroker)
+ [AWS SDK for Python](/goto/boto3/mq-2017-11-27/UpdateBroker)
+ [AWS SDK for Ruby V3](/goto/SdkForRubyV3/mq-2017-11-27/UpdateBroker)

### DeleteBroker
<a name="DeleteBroker-see-also"></a>
+ [AWS Command Line Interface V2](/goto/cli2/mq-2017-11-27/DeleteBroker)
+ [AWS SDK for .NET V4](/goto/DotNetSDKV4/mq-2017-11-27/DeleteBroker)
+ [AWS SDK for C\$1\$1](/goto/SdkForCpp/mq-2017-11-27/DeleteBroker)
+ [AWS SDK for Go v2](/goto/SdkForGoV2/mq-2017-11-27/DeleteBroker)
+ [AWS SDK for Java V2](/goto/SdkForJavaV2/mq-2017-11-27/DeleteBroker)
+ [AWS SDK for JavaScript V3](/goto/SdkForJavaScriptV3/mq-2017-11-27/DeleteBroker)
+ [AWS SDK for Kotlin](/goto/SdkForKotlin/mq-2017-11-27/DeleteBroker)
+ [AWS SDK for PHP V3](/goto/SdkForPHPV3/mq-2017-11-27/DeleteBroker)
+ [AWS SDK for Python](/goto/boto3/mq-2017-11-27/DeleteBroker)
+ [AWS SDK for Ruby V3](/goto/SdkForRubyV3/mq-2017-11-27/DeleteBroker)

# Broker Engine Types
<a name="broker-engine-types"></a>

Retrieve information about available broker engines. AWS does not support all instance types in all availability zones and regions. For more information, see the [ActiveMQ version management](https://docs.aws.amazon.com//amazon-mq/latest/developer-guide/activemq-version-management.html) and the [RabbitMQ version management](https://docs.aws.amazon.com//amazon-mq/latest/developer-guide/rabbitmq-version-management.html) sections in the Amazon MQ Developer Guide.

This API will tell you, for a given region and availability zone, which broker engine types and engine versions you can create.

## URI
<a name="broker-engine-types-url"></a>

`/v1/broker-engine-types`

## HTTP methods
<a name="broker-engine-types-http-methods"></a>

### GET
<a name="broker-engine-typesget"></a>

**Operation ID:** `DescribeBrokerEngineTypes`

Describe available engine types and versions.


**Query parameters**  

| Name | Type | Required | Description | 
| --- |--- |--- |--- |
| engineType | String | False | Filter response by engine type. | 
| nextToken | String | False | The token that specifies the next page of results Amazon MQ should return. To request the first page, leave nextToken empty. | 
| maxResults | String | False | The maximum number of brokers that Amazon MQ can return per page (20 by default). This value must be an integer from 5 to 100. | 


**Responses**  

| Status code | Response model | Description | 
| --- |--- |--- |
| 200 |  BrokerEngineTypeOutput | HTTP Status Code 200: OK. | 
| 400 | Error | HTTP Status Code 400: Bad request due to incorrect input. Correct your request and then retry it. | 
| 403 | Error | HTTP Status Code 403: Access forbidden. Correct your credentials and then retry your request. | 
| 500 | Error | HTTP Status Code 500: Unexpected internal server error. Retrying your request might resolve the issue. | 

### OPTIONS
<a name="broker-engine-typesoptions"></a>


**Responses**  

| Status code | Response model | Description | 
| --- |--- |--- |
| 200 | None | Default response for CORS method | 

## Schemas
<a name="broker-engine-types-schemas"></a>

### Response bodies
<a name="broker-engine-types-response-examples"></a>

#### BrokerEngineTypeOutput schema
<a name="broker-engine-types-response-body-brokerenginetypeoutput-example"></a>

```
{
  "nextToken": "string",
  "maxResults": integer,
  "brokerEngineTypes": [
    {
      "engineVersions": [
        {
          "name": "string"
        }
      ],
      "engineType": enum
    }
  ]
}
```

#### Error schema
<a name="broker-engine-types-response-body-error-example"></a>

```
{
  "errorAttribute": "string",
  "message": "string"
}
```

## Properties
<a name="broker-engine-types-properties"></a>

### BrokerEngineType
<a name="broker-engine-types-model-brokerenginetype"></a>

Types of broker engines.


| Property | Type | Required | Description | 
| --- |--- |--- |--- |
| engineType | [EngineType](#broker-engine-types-model-enginetype) | False | The broker's engine type. | 
| engineVersions | Array of type [EngineVersion](#broker-engine-types-model-engineversion) | False | The list of engine versions. | 

### BrokerEngineTypeOutput
<a name="broker-engine-types-model-brokerenginetypeoutput"></a>

Returns a list of broker engine type.


| Property | Type | Required | Description | 
| --- |--- |--- |--- |
| brokerEngineTypes | Array of type [BrokerEngineType](#broker-engine-types-model-brokerenginetype) | False | List of available engine types and versions. | 
| maxResults | integerMinimum: 5Maximum: 100 | True | Required. The maximum number of engine types that can be returned per page (20 by default). This value must be an integer from 5 to 100. | 
| nextToken | string | False | The token that specifies the next page of results Amazon MQ should return. To request the first page, leave nextToken empty. | 

### EngineType
<a name="broker-engine-types-model-enginetype"></a>

The type of broker engine. Amazon MQ supports ActiveMQ and RabbitMQ.
+ `ACTIVEMQ`
+ `RABBITMQ`

### EngineVersion
<a name="broker-engine-types-model-engineversion"></a>

Id of the engine version.


| Property | Type | Required | Description | 
| --- |--- |--- |--- |
| name | string | False | Id for the version. | 

### Error
<a name="broker-engine-types-model-error"></a>

Returns information about an error.


| Property | Type | Required | Description | 
| --- |--- |--- |--- |
| errorAttribute | string | False | The attribute which caused the error. | 
| message | string | False | The explanation of the error. | 

## See also
<a name="broker-engine-types-see-also"></a>

For more information about using this API in one of the language-specific AWS SDKs and references, see the following:

### DescribeBrokerEngineTypes
<a name="DescribeBrokerEngineTypes-see-also"></a>
+ [AWS Command Line Interface V2](/goto/cli2/mq-2017-11-27/DescribeBrokerEngineTypes)
+ [AWS SDK for .NET V4](/goto/DotNetSDKV4/mq-2017-11-27/DescribeBrokerEngineTypes)
+ [AWS SDK for C\$1\$1](/goto/SdkForCpp/mq-2017-11-27/DescribeBrokerEngineTypes)
+ [AWS SDK for Go v2](/goto/SdkForGoV2/mq-2017-11-27/DescribeBrokerEngineTypes)
+ [AWS SDK for Java V2](/goto/SdkForJavaV2/mq-2017-11-27/DescribeBrokerEngineTypes)
+ [AWS SDK for JavaScript V3](/goto/SdkForJavaScriptV3/mq-2017-11-27/DescribeBrokerEngineTypes)
+ [AWS SDK for Kotlin](/goto/SdkForKotlin/mq-2017-11-27/DescribeBrokerEngineTypes)
+ [AWS SDK for PHP V3](/goto/SdkForPHPV3/mq-2017-11-27/DescribeBrokerEngineTypes)
+ [AWS SDK for Python](/goto/boto3/mq-2017-11-27/DescribeBrokerEngineTypes)
+ [AWS SDK for Ruby V3](/goto/SdkForRubyV3/mq-2017-11-27/DescribeBrokerEngineTypes)

# Broker Instance Options
<a name="broker-instance-options"></a>

You can retrieve information about broker instances. For more information about the different components of an Amazon MQ broker, see [How Amazon MQ works](https://docs.aws.amazon.com//amazon-mq/latest/developer-guide/amazon-mq-how-it-works.html) in the *Amazon MQ Developer Guide*.

## URI
<a name="broker-instance-options-url"></a>

`/v1/broker-instance-options`

## HTTP methods
<a name="broker-instance-options-http-methods"></a>

### GET
<a name="broker-instance-optionsget"></a>

**Operation ID:** `DescribeBrokerInstanceOptions`

Describe available broker instance options.


**Query parameters**  

| Name | Type | Required | Description | 
| --- |--- |--- |--- |
| hostInstanceType | String | False | Filter response by host instance type. | 
| nextToken | String | False | The token that specifies the next page of results Amazon MQ should return. To request the first page, leave nextToken empty. | 
| storageType | String | False | Filter response by storage type. | 
| maxResults | String | False | The maximum number of brokers that Amazon MQ can return per page (20 by default). This value must be an integer from 5 to 100. | 
| engineType | String | False | Filter response by engine type. | 


**Responses**  

| Status code | Response model | Description | 
| --- |--- |--- |
| 200 |  BrokerInstanceOptionsOutput | HTTP Status Code 200: OK. | 
| 400 | Error | HTTP Status Code 400: Bad request due to incorrect input. Correct your request and then retry it. | 
| 403 | Error | HTTP Status Code 403: Access forbidden. Correct your credentials and then retry your request. | 
| 500 | Error | HTTP Status Code 500: Unexpected internal server error. Retrying your request might resolve the issue. | 

### OPTIONS
<a name="broker-instance-optionsoptions"></a>


**Responses**  

| Status code | Response model | Description | 
| --- |--- |--- |
| 200 | None | Default response for CORS method | 

## Schemas
<a name="broker-instance-options-schemas"></a>

### Response bodies
<a name="broker-instance-options-response-examples"></a>

#### BrokerInstanceOptionsOutput schema
<a name="broker-instance-options-response-body-brokerinstanceoptionsoutput-example"></a>

```
{
  "nextToken": "string",
  "maxResults": integer,
  "brokerInstanceOptions": [
    {
      "supportedDeploymentModes": [
        enum
      ],
      "supportedEngineVersions": [
        "string"
      ],
      "storageType": enum,
      "engineType": enum,
      "availabilityZones": [
        {
          "name": "string"
        }
      ],
      "hostInstanceType": "string"
    }
  ]
}
```

#### Error schema
<a name="broker-instance-options-response-body-error-example"></a>

```
{
  "errorAttribute": "string",
  "message": "string"
}
```

## Properties
<a name="broker-instance-options-properties"></a>

### AvailabilityZone
<a name="broker-instance-options-model-availabilityzone"></a>

Name of the availability zone.


| Property | Type | Required | Description | 
| --- |--- |--- |--- |
| name | string | False | Id for the availability zone. | 

### BrokerInstanceOption
<a name="broker-instance-options-model-brokerinstanceoption"></a>

Option for host instance type.


| Property | Type | Required | Description | 
| --- |--- |--- |--- |
| availabilityZones | Array of type [AvailabilityZone](#broker-instance-options-model-availabilityzone) | False | The list of available az. | 
| engineType | [EngineType](#broker-instance-options-model-enginetype) | False | The broker's engine type. | 
| hostInstanceType | string | False | The broker's instance type. | 
| storageType | [BrokerStorageType](#broker-instance-options-model-brokerstoragetype) | False | The broker's storage type. | 
| supportedDeploymentModes | Array of type [DeploymentMode](#broker-instance-options-model-deploymentmode) | False | The list of supported deployment modes. | 
| supportedEngineVersions | Array of type string | False | The list of supported engine versions. | 

### BrokerInstanceOptionsOutput
<a name="broker-instance-options-model-brokerinstanceoptionsoutput"></a>

Returns a list of broker instance options.


| Property | Type | Required | Description | 
| --- |--- |--- |--- |
| brokerInstanceOptions | Array of type [BrokerInstanceOption](#broker-instance-options-model-brokerinstanceoption) | False | List of available broker instance options. | 
| maxResults | integerMinimum: 5Maximum: 100 | True | Required. The maximum number of instance options that can be returned per page (20 by default). This value must be an integer from 5 to 100. | 
| nextToken | string | False | The token that specifies the next page of results Amazon MQ should return. To request the first page, leave nextToken empty. | 

### BrokerStorageType
<a name="broker-instance-options-model-brokerstoragetype"></a>

The broker's storage type.

**Important**  
 `EFS` is not supported for RabbitMQ engine type.
+ `EBS`
+ `EFS`

### DeploymentMode
<a name="broker-instance-options-model-deploymentmode"></a>

The broker's deployment mode.
+ `SINGLE_INSTANCE`
+ `ACTIVE_STANDBY_MULTI_AZ`
+ `CLUSTER_MULTI_AZ`

### EngineType
<a name="broker-instance-options-model-enginetype"></a>

The type of broker engine. Amazon MQ supports ActiveMQ and RabbitMQ.
+ `ACTIVEMQ`
+ `RABBITMQ`

### Error
<a name="broker-instance-options-model-error"></a>

Returns information about an error.


| Property | Type | Required | Description | 
| --- |--- |--- |--- |
| errorAttribute | string | False | The attribute which caused the error. | 
| message | string | False | The explanation of the error. | 

## See also
<a name="broker-instance-options-see-also"></a>

For more information about using this API in one of the language-specific AWS SDKs and references, see the following:

### DescribeBrokerInstanceOptions
<a name="DescribeBrokerInstanceOptions-see-also"></a>
+ [AWS Command Line Interface V2](/goto/cli2/mq-2017-11-27/DescribeBrokerInstanceOptions)
+ [AWS SDK for .NET V4](/goto/DotNetSDKV4/mq-2017-11-27/DescribeBrokerInstanceOptions)
+ [AWS SDK for C\$1\$1](/goto/SdkForCpp/mq-2017-11-27/DescribeBrokerInstanceOptions)
+ [AWS SDK for Go v2](/goto/SdkForGoV2/mq-2017-11-27/DescribeBrokerInstanceOptions)
+ [AWS SDK for Java V2](/goto/SdkForJavaV2/mq-2017-11-27/DescribeBrokerInstanceOptions)
+ [AWS SDK for JavaScript V3](/goto/SdkForJavaScriptV3/mq-2017-11-27/DescribeBrokerInstanceOptions)
+ [AWS SDK for Kotlin](/goto/SdkForKotlin/mq-2017-11-27/DescribeBrokerInstanceOptions)
+ [AWS SDK for PHP V3](/goto/SdkForPHPV3/mq-2017-11-27/DescribeBrokerInstanceOptions)
+ [AWS SDK for Python](/goto/boto3/mq-2017-11-27/DescribeBrokerInstanceOptions)
+ [AWS SDK for Ruby V3](/goto/SdkForRubyV3/mq-2017-11-27/DescribeBrokerInstanceOptions)

# Broker Reboot
<a name="brokers-broker-id-reboot"></a>

To apply a new configuration to a broker or to initiate a failover in a multi-AZ broker, you can reboot the broker. In addition, if your broker becomes unresponsive, you can reboot it to recover from a faulty state.

**Note**  
You can reboot only a broker with the RUNNING status.

## URI
<a name="brokers-broker-id-reboot-url"></a>

`/v1/brokers/broker-id/reboot`

## HTTP methods
<a name="brokers-broker-id-reboot-http-methods"></a>

### POST
<a name="brokers-broker-id-rebootpost"></a>

**Operation ID:** `RebootBroker`

Reboots a broker. Note: This API is asynchronous.


**Path parameters**  

| Name | Type | Required | Description | 
| --- |--- |--- |--- |
| broker-id | String | True | The unique ID that Amazon MQ generates for the broker. | 


**Responses**  

| Status code | Response model | Description | 
| --- |--- |--- |
| 200 | None | HTTP Status Code 200: OK. | 
| 400 | Error | HTTP Status Code 400: Bad request due to incorrect input. Correct your request and then retry it. | 
| 403 | Error | HTTP Status Code 403: Access forbidden. Correct your credentials and then retry your request. | 
| 404 | Error | HTTP Status Code 404: Resource not found due to incorrect input. Correct your request and then retry it. | 
| 500 | Error | HTTP Status Code 500: Unexpected internal server error. Retrying your request might resolve the issue. | 

### OPTIONS
<a name="brokers-broker-id-rebootoptions"></a>


**Path parameters**  

| Name | Type | Required | Description | 
| --- |--- |--- |--- |
| broker-id | String | True | The unique ID that Amazon MQ generates for the broker. | 


**Responses**  

| Status code | Response model | Description | 
| --- |--- |--- |
| 200 | None | Default response for CORS method | 

## Schemas
<a name="brokers-broker-id-reboot-schemas"></a>

### Response bodies
<a name="brokers-broker-id-reboot-response-examples"></a>

#### Error schema
<a name="brokers-broker-id-reboot-response-body-error-example"></a>

```
{
  "errorAttribute": "string",
  "message": "string"
}
```

## Properties
<a name="brokers-broker-id-reboot-properties"></a>

### Error
<a name="brokers-broker-id-reboot-model-error"></a>

Returns information about an error.


| Property | Type | Required | Description | 
| --- |--- |--- |--- |
| errorAttribute | string | False | The attribute which caused the error. | 
| message | string | False | The explanation of the error. | 

## See also
<a name="brokers-broker-id-reboot-see-also"></a>

For more information about using this API in one of the language-specific AWS SDKs and references, see the following:

### RebootBroker
<a name="RebootBroker-see-also"></a>
+ [AWS Command Line Interface V2](/goto/cli2/mq-2017-11-27/RebootBroker)
+ [AWS SDK for .NET V4](/goto/DotNetSDKV4/mq-2017-11-27/RebootBroker)
+ [AWS SDK for C\$1\$1](/goto/SdkForCpp/mq-2017-11-27/RebootBroker)
+ [AWS SDK for Go v2](/goto/SdkForGoV2/mq-2017-11-27/RebootBroker)
+ [AWS SDK for Java V2](/goto/SdkForJavaV2/mq-2017-11-27/RebootBroker)
+ [AWS SDK for JavaScript V3](/goto/SdkForJavaScriptV3/mq-2017-11-27/RebootBroker)
+ [AWS SDK for Kotlin](/goto/SdkForKotlin/mq-2017-11-27/RebootBroker)
+ [AWS SDK for PHP V3](/goto/SdkForPHPV3/mq-2017-11-27/RebootBroker)
+ [AWS SDK for Python](/goto/boto3/mq-2017-11-27/RebootBroker)
+ [AWS SDK for Ruby V3](/goto/SdkForRubyV3/mq-2017-11-27/RebootBroker)

# Brokers
<a name="brokers"></a>

This is a collection of brokers. A broker is a message broker environment running on Amazon MQ. It is the basic building block of Amazon MQ. For more information, see [Broker instance types](https://docs.aws.amazon.com//amazon-mq/latest/developer-guide/broker-instance-types.html) in the *Amazon MQ Developer Guide*.

## URI
<a name="brokers-url"></a>

`/v1/brokers`

## HTTP methods
<a name="brokers-http-methods"></a>

### GET
<a name="brokersget"></a>

**Operation ID:** `ListBrokers`

Returns a list of all brokers.


**Query parameters**  

| Name | Type | Required | Description | 
| --- |--- |--- |--- |
| nextToken | String | False | The token that specifies the next page of results Amazon MQ should return. To request the first page, leave nextToken empty. | 
| maxResults | String | False | The maximum number of brokers that Amazon MQ can return per page (20 by default). This value must be an integer from 5 to 100. | 


**Responses**  

| Status code | Response model | Description | 
| --- |--- |--- |
| 200 |  ListBrokersOutput | HTTP Status Code 200: OK. | 
| 400 | Error | HTTP Status Code 400: Bad request due to incorrect input. Correct your request and then retry it. | 
| 403 | Error | HTTP Status Code 403: Access forbidden. Correct your credentials and then retry your request. | 
| 500 | Error | HTTP Status Code 500: Unexpected internal server error. Retrying your request might resolve the issue. | 

### POST
<a name="brokerspost"></a>

**Operation ID:** `CreateBroker`

Creates a broker. Note: This API is asynchronous.

To create a broker, you must either use the `AmazonMQFullAccess` IAM policy or include the following EC2 permissions in your IAM policy.
+  `ec2:CreateNetworkInterface` 

  This permission is required to allow Amazon MQ to create an elastic network interface (ENI) on behalf of your account.
+  `ec2:CreateNetworkInterfacePermission` 

  This permission is required to attach the ENI to the broker instance.
+  `ec2:DeleteNetworkInterface` 
+  `ec2:DeleteNetworkInterfacePermission` 
+  `ec2:DetachNetworkInterface` 
+  `ec2:DescribeInternetGateways` 
+  `ec2:DescribeNetworkInterfaces` 
+  `ec2:DescribeNetworkInterfacePermissions` 
+  `ec2:DescribeRouteTables` 
+  `ec2:DescribeSecurityGroups` 
+  `ec2:DescribeSubnets` 
+  `ec2:DescribeVpcs` 

For more information, see [Create an IAM User and Get Your AWS Credentials](https://docs.aws.amazon.com//amazon-mq/latest/developer-guide/amazon-mq-setting-up.html#create-iam-user) and [Never Modify or Delete the Amazon MQ Elastic Network Interface](https://docs.aws.amazon.com//amazon-mq/latest/developer-guide/connecting-to-amazon-mq.html#never-modify-delete-elastic-network-interface) in the *Amazon MQ Developer Guide*.


**Responses**  

| Status code | Response model | Description | 
| --- |--- |--- |
| 200 |  CreateBrokerOutput | HTTP Status Code 200: OK. | 
| 400 | Error | HTTP Status Code 400: Bad request due to incorrect input. Correct your request and then retry it. | 
| 401 | Error | HTTP Status Code 401: Unauthorized request. The provided credentials couldn't be validated. | 
| 403 | Error | HTTP Status Code 403: Access forbidden. Correct your credentials and then retry your request. | 
| 409 | Error | HTTP Status Code 409: Configuration ID is already in use. Remove the configuration from all brokers and retry the request. | 
| 500 | Error | HTTP Status Code 500: Unexpected internal server error. Retrying your request might resolve the issue. | 

### OPTIONS
<a name="brokersoptions"></a>


**Responses**  

| Status code | Response model | Description | 
| --- |--- |--- |
| 200 | None | Default response for CORS method | 

## Schemas
<a name="brokers-schemas"></a>

### Request bodies
<a name="brokers-request-examples"></a>

#### POST schema
<a name="brokers-request-body-post-example"></a>

```
{
  "engineVersion": "string",
  "deploymentMode": enum,
  "maintenanceWindowStartTime": {
    "dayOfWeek": enum,
    "timeZone": "string",
    "timeOfDay": "string"
  },
  "configuration": {
    "id": "string",
    "revision": integer
  },
  "authenticationStrategy": enum,
  "engineType": enum,
  "hostInstanceType": "string",
  "users": [
    {
      "password": "string",
      "replicationUser": boolean,
      "groups": [
        "string"
      ],
      "consoleAccess": boolean,
      "username": "string"
    }
  ],
  "tags": {
  },
  "dataReplicationMode": enum,
  "creatorRequestId": "string",
  "storageConfiguration": {
    "efs": {
      "throughputMode": enum
    }
  },
  "encryptionOptions": {
    "useAwsOwnedKey": boolean,
    "kmsKeyId": "string"
  },
  "publiclyAccessible": boolean,
  "storageType": enum,
  "securityGroups": [
    "string"
  ],
  "dataReplicationPrimaryBrokerArn": "string",
  "brokerName": "string",
  "logs": {
    "general": boolean,
    "audit": boolean
  },
  "ldapServerMetadata": {
    "roleSearchMatching": "string",
    "serviceAccountPassword": "string",
    "roleBase": "string",
    "hosts": [
      "string"
    ],
    "roleName": "string",
    "userBase": "string",
    "roleSearchSubtree": boolean,
    "serviceAccountUsername": "string",
    "userRoleName": "string",
    "userSearchMatching": "string",
    "userSearchSubtree": boolean
  },
  "autoMinorVersionUpgrade": boolean,
  "subnetIds": [
    "string"
  ]
}
```

### Response bodies
<a name="brokers-response-examples"></a>

#### ListBrokersOutput schema
<a name="brokers-response-body-listbrokersoutput-example"></a>

```
{
  "brokerSummaries": [
    {
      "brokerArn": "string",
      "brokerId": "string",
      "deploymentMode": enum,
      "created": "string",
      "brokerState": enum,
      "engineType": enum,
      "brokerName": "string",
      "hostInstanceType": "string"
    }
  ],
  "nextToken": "string"
}
```

#### CreateBrokerOutput schema
<a name="brokers-response-body-createbrokeroutput-example"></a>

```
{
  "brokerArn": "string",
  "brokerId": "string"
}
```

#### Error schema
<a name="brokers-response-body-error-example"></a>

```
{
  "errorAttribute": "string",
  "message": "string"
}
```

## Properties
<a name="brokers-properties"></a>

### AuthenticationStrategy
<a name="brokers-model-authenticationstrategy"></a>

Optional. The authentication strategy used to secure the broker. The default is `SIMPLE`.
+ `SIMPLE`
+ `LDAP`
+ `CONFIG_MANAGED`

### BrokerState
<a name="brokers-model-brokerstate"></a>

The broker's status.
+ `CREATION_IN_PROGRESS`
+ `CREATION_FAILED`
+ `DELETION_IN_PROGRESS`
+ `RUNNING`
+ `REBOOT_IN_PROGRESS`
+ `CRITICAL_ACTION_REQUIRED`
+ `REPLICA`

### BrokerStorageConfiguration
<a name="brokers-model-brokerstorageconfiguration"></a>

The storage configurations of a broker.


| Property | Type | Required | Description | 
| --- |--- |--- |--- |
| efs | [EfsBrokerStorageConfiguration](#brokers-model-efsbrokerstorageconfiguration) | False |  | 

### BrokerStorageType
<a name="brokers-model-brokerstoragetype"></a>

The broker's storage type.

**Important**  
 `EFS` is not supported for RabbitMQ engine type.
+ `EBS`
+ `EFS`

### BrokerSummary
<a name="brokers-model-brokersummary"></a>

Returns information about all brokers.


| Property | Type | Required | Description | 
| --- |--- |--- |--- |
| brokerArn | string | False | The broker's Amazon Resource Name (ARN). | 
| brokerId | string | False | The unique ID that Amazon MQ generates for the broker. | 
| brokerName | string | False | The broker's name. This value is unique in your AWS account, 1-50 characters long, and containing only letters, numbers, dashes, and underscores, and must not contain white spaces, brackets, wildcard characters, or special characters. | 
| brokerState | [BrokerState](#brokers-model-brokerstate) | False | The broker's status. | 
| created | stringFormat: date-time | False | The time when the broker was created. | 
| deploymentMode | [DeploymentMode](#brokers-model-deploymentmode) | True | The broker's deployment mode. | 
| engineType | [EngineType](#brokers-model-enginetype) | True | The type of broker engine. | 
| hostInstanceType | string | False | The broker's instance type. | 

### ConfigurationId
<a name="brokers-model-configurationid"></a>

A list of information about the configuration.


| Property | Type | Required | Description | 
| --- |--- |--- |--- |
| id | string | True | Required. The unique ID that Amazon MQ generates for the configuration. | 
| revision | integer | False | The revision number of the configuration. | 

### CreateBrokerInput
<a name="brokers-model-createbrokerinput"></a>

Creates a broker.


| Property | Type | Required | Description | 
| --- |--- |--- |--- |
| authenticationStrategy | [AuthenticationStrategy](#brokers-model-authenticationstrategy) | False | Optional. The authentication strategy used to secure the broker. The default is `SIMPLE`. | 
| autoMinorVersionUpgrade | boolean | False | Enables automatic upgrades to new patch versions for brokers as new versions are released and supported by Amazon MQ. Automatic upgrades occur during the scheduled maintenance window or after a manual broker reboot. Set to `true` by default, if no value is specified.Must be set to `true` for ActiveMQ brokers version 5.18 and above and for RabbitMQ brokers version 3.13 and above. | 
| brokerName | string | True | Required. The broker's name. This value must be unique in your AWS account, 1-50 characters long, must contain only letters, numbers, dashes, and underscores, and must not contain white spaces, brackets, wildcard characters, or special characters.  Do not add personally identifiable information (PII) or other confidential or sensitive information in broker names. Broker names are accessible to other AWS services, including CloudWatch Logs. Broker names are not intended to be used for private or sensitive data.   | 
| configuration | [ConfigurationId](#brokers-model-configurationid) | False | A list of information about the configuration. | 
| creatorRequestId | string | False | The unique ID that the requester receives for the created broker. Amazon MQ passes your ID with the API action.  We recommend using a Universally Unique Identifier (UUID) for the creatorRequestId. You may omit the `creatorRequestId` if your application doesn't require idempotency.   | 
| dataReplicationMode | [DataReplicationMode](#brokers-model-datareplicationmode) | False | Defines whether this broker is a part of a data replication pair. | 
| dataReplicationPrimaryBrokerArn | string | False | The Amazon Resource Name (ARN) of the primary broker that is used to replicate data from in a data replication pair, and is applied to the replica broker. Must be set when dataReplicationMode is set to CRDR. | 
| deploymentMode | [DeploymentMode](#brokers-model-deploymentmode) | True | Required. The broker's deployment mode. | 
| encryptionOptions | [EncryptionOptions](#brokers-model-encryptionoptions) | False | Encryption options for the broker.  | 
| engineType | [EngineType](#brokers-model-enginetype) | True | Required. The type of broker engine. Currently, Amazon MQ supports `ACTIVEMQ` and `RABBITMQ`. | 
| engineVersion | string | False | The broker engine version. Defaults to the latest available version for the specified broker engine type. For more information, see the [ActiveMQ version management](https://docs.aws.amazon.com//amazon-mq/latest/developer-guide/activemq-version-management.html) and the [RabbitMQ version management](https://docs.aws.amazon.com//amazon-mq/latest/developer-guide/rabbitmq-version-management.html) sections in the Amazon MQ Developer Guide. | 
| hostInstanceType | string | True | Required. The broker's instance type. | 
| ldapServerMetadata | [LdapServerMetadataInput](#brokers-model-ldapservermetadatainput) | False | Optional. The metadata of the LDAP server used to authenticate and authorize connections to the broker. Does not apply to RabbitMQ brokers. | 
| logs | [Logs](#brokers-model-logs) | False | Enables Amazon CloudWatch logging for brokers. | 
| maintenanceWindowStartTime | [WeeklyStartTime](#brokers-model-weeklystarttime) | False | The parameters that determine the WeeklyStartTime. | 
| publiclyAccessible | boolean | True | Enables connections from applications outside of the VPC that hosts the broker's subnets. Set to `false` by default, if no value is provided. | 
| securityGroups | Array of type string | False | The list of rules (1 minimum, 125 maximum) that authorize connections to brokers. | 
| storageConfiguration | [BrokerStorageConfiguration](#brokers-model-brokerstorageconfiguration) | False | The broker's storage configuration. | 
| storageType | [BrokerStorageType](#brokers-model-brokerstoragetype) | False | The broker's storage type. | 
| subnetIds | Array of type string | False | The list of groups that define which subnets and IP ranges the broker can use from different Availability Zones. If you specify more than one subnet, the subnets must be in different Availability Zones. Amazon MQ will not be able to create VPC endpoints for your broker with multiple subnets in the same Availability Zone. A SINGLE\$1INSTANCE deployment requires one subnet (for example, the default subnet). An ACTIVE\$1STANDBY\$1MULTI\$1AZ Amazon MQ for ActiveMQ deployment requires two subnets. A CLUSTER\$1MULTI\$1AZ Amazon MQ for RabbitMQ deployment has no subnet requirements when deployed with public accessibility. Deployment without public accessibility requires at least one subnet.  If you specify subnets in a [shared VPC](https://docs.aws.amazon.com/vpc/latest/userguide/vpc-sharing.html) for a RabbitMQ broker, the associated VPC to which the specified subnets belong must be owned by your AWS account. Amazon MQ will not be able to create VPC endpoints in VPCs that are not owned by your AWS account.  | 
| tags | object | False | Create tags when creating the broker. | 
| users | Array of type [User](#brokers-model-user) | False | The list of broker users (persons or applications) who can access queues and topics. For Amazon MQ for RabbitMQ brokers, one and only one administrative user is accepted and created when a broker is first provisioned. All subsequent broker users are created by making RabbitMQ API calls directly to brokers or via the RabbitMQ web console.When OAuth 2.0 is enabled, the broker accepts one or no users. | 

### CreateBrokerOutput
<a name="brokers-model-createbrokeroutput"></a>

Returns information about the created broker.


| Property | Type | Required | Description | 
| --- |--- |--- |--- |
| brokerArn | string | False | The broker's Amazon Resource Name (ARN). | 
| brokerId | string | False | The unique ID that Amazon MQ generates for the broker. | 

### DataReplicationMode
<a name="brokers-model-datareplicationmode"></a>

Specifies whether a broker is a part of a data replication pair.
+ `NONE`
+ `CRDR`

### DeploymentMode
<a name="brokers-model-deploymentmode"></a>

The broker's deployment mode.
+ `SINGLE_INSTANCE`
+ `ACTIVE_STANDBY_MULTI_AZ`
+ `CLUSTER_MULTI_AZ`

### EfsBrokerStorageConfiguration
<a name="brokers-model-efsbrokerstorageconfiguration"></a>

The storage configuration of an EFS broker storage


| Property | Type | Required | Description | 
| --- |--- |--- |--- |
| throughputMode | stringValues: `ELASTIC \| STANDARD` | False | Throughput mode of EFS broker storage | 

### EncryptionOptions
<a name="brokers-model-encryptionoptions"></a>

Encryption options for the broker.


| Property | Type | Required | Description | 
| --- |--- |--- |--- |
| kmsKeyId | string | False | The customer master key (CMK) to use for the A AWS KMS (KMS). This key is used to encrypt your data at rest. If not provided, Amazon MQ will use a default CMK to encrypt your data. | 
| useAwsOwnedKey | boolean | True | Enables the use of an AWS owned CMK using AWS KMS (KMS). Set to `true` by default, if no value is provided, for example, for RabbitMQ brokers. | 

### EngineType
<a name="brokers-model-enginetype"></a>

The type of broker engine. Amazon MQ supports ActiveMQ and RabbitMQ.
+ `ACTIVEMQ`
+ `RABBITMQ`

### Error
<a name="brokers-model-error"></a>

Returns information about an error.


| Property | Type | Required | Description | 
| --- |--- |--- |--- |
| errorAttribute | string | False | The attribute which caused the error. | 
| message | string | False | The explanation of the error. | 

### LdapServerMetadataInput
<a name="brokers-model-ldapservermetadatainput"></a>

Optional. The metadata of the LDAP server used to authenticate and authorize connections to the broker.

**Important**  
Does not apply to RabbitMQ brokers.


| Property | Type | Required | Description | 
| --- |--- |--- |--- |
| hosts | Array of type string | True | Specifies the location of the LDAP server such as AWS Directory Service for Microsoft Active Directory. Optional failover server. | 
| roleBase | string | True | The distinguished name of the node in the directory information tree (DIT) to search for roles or groups. For example, `ou=group, ou=corp, dc=corp, dc=example, dc=com`. | 
| roleName | string | False | Specifies the LDAP attribute that identifies the group name attribute in the object returned from the group membership query. | 
| roleSearchMatching | string | True | The LDAP search filter used to find roles within the `roleBase`. The distinguished name of the user matched by `userSearchMatching` is substituted into the `{0}` placeholder in the search filter. The client's username is substituted into the `{1}` placeholder. For example, if you set this option to `(member=uid={1})`for the user `janedoe`, the search filter becomes `(member=uid=janedoe)` after string substitution. It matches all role entries that have a member attribute equal to `uid=janedoe` under the subtree selected by the `roleBase`. | 
| roleSearchSubtree | boolean | False | The directory search scope for the role. If set to true, scope is to search the entire subtree. | 
| serviceAccountPassword | string | True | Service account password. A service account is an account in your LDAP server that has access to initiate a connection. For example, `cn=admin,dc=corp, dc=example, dc=com`. | 
| serviceAccountUsername | string | True | Service account username. A service account is an account in your LDAP server that has access to initiate a connection. For example, `cn=admin,dc=corp, dc=example, dc=com`. | 
| userBase | string | True | Select a particular subtree of the directory information tree (DIT) to search for user entries. The subtree is specified by a DN, which specifies the base node of the subtree. For example, by setting this option to `ou=Users,ou=corp, dc=corp, dc=example, dc=com`, the search for user entries is restricted to the subtree beneath `ou=Users, ou=corp, dc=corp, dc=example, dc=com`. | 
| userRoleName | string | False | Specifies the name of the LDAP attribute for the user group membership. | 
| userSearchMatching | string | True | The LDAP search filter used to find users within the `userBase`. The client's username is substituted into the `{0}` placeholder in the search filter. For example, if this option is set to `(uid={0})` and the received username is `janedoe`, the search filter becomes `(uid=janedoe)` after string substitution. It will result in matching an entry like `uid=janedoe, ou=Users,ou=corp, dc=corp, dc=example, dc=com`. | 
| userSearchSubtree | boolean | False | The directory search scope for the user. If set to true, scope is to search the entire subtree. | 

### ListBrokersOutput
<a name="brokers-model-listbrokersoutput"></a>

A list of information about all brokers.


| Property | Type | Required | Description | 
| --- |--- |--- |--- |
| brokerSummaries | Array of type [BrokerSummary](#brokers-model-brokersummary) | False | A list of information about all brokers. | 
| nextToken | string | False | The token that specifies the next page of results Amazon MQ should return. To request the first page, leave nextToken empty. | 

### Logs
<a name="brokers-model-logs"></a>

The list of information about logs to be enabled for the specified broker.


| Property | Type | Required | Description | 
| --- |--- |--- |--- |
| audit | boolean | False | Enables audit logging. Every user management action made using JMX or the ActiveMQ Web Console is logged. Does not apply to RabbitMQ brokers. | 
| general | boolean | False | Enables general logging. | 

### User
<a name="brokers-model-user"></a>

A user associated with the broker. For Amazon MQ for RabbitMQ brokers, one and only one administrative user is accepted and created when a broker is first provisioned. All subsequent broker users are created by making RabbitMQ API calls directly to brokers or via the RabbitMQ web console. 


| Property | Type | Required | Description | 
| --- |--- |--- |--- |
| consoleAccess | boolean | False | Enables access to the ActiveMQ Web Console for the ActiveMQ user. Does not apply to RabbitMQ brokers. | 
| groups | Array of type string | False | The list of groups (20 maximum) to which the ActiveMQ user belongs. This value can contain only alphanumeric characters, dashes, periods, underscores, and tildes (- . \$1 \$1). This value must be 2-100 characters long. Does not apply to RabbitMQ brokers. | 
| password | stringFormat: password | True |  Required. The password of the user. This value must be at least 12 characters long, must contain at least 4 unique characters, and must not contain commas, colons, or equal signs (,:=). | 
| replicationUser | boolean | False | Defines if this user is intended for CRDR replication purposes. | 
| username | string | True | The username of the broker user. The following restrictions apply to broker usernames:   For Amazon MQ for ActiveMQ brokers, this value can contain only alphanumeric characters, dashes, periods, underscores, and tildes (- . \$1 \$1). This value must be 2-100 characters long.    For Amazon MQ for RabbitMQ brokers, this value can contain only alphanumeric characters, dashes, periods, underscores (- . \$1). This value must not contain a tilde (\$1) character. Amazon MQ prohibts using `guest` as a valid usename. This value must be 2-100 characters long.    Do not add personally identifiable information (PII) or other confidential or sensitive information in broker usernames. Broker usernames are accessible to other AWS services, including CloudWatch Logs. Broker usernames are not intended to be used for private or sensitive data.   | 

### WeeklyStartTime
<a name="brokers-model-weeklystarttime"></a>

The scheduled time period relative to UTC during which Amazon MQ begins to apply pending updates or patches to the broker.


| Property | Type | Required | Description | 
| --- |--- |--- |--- |
| dayOfWeek | stringValues: `MONDAY \| TUESDAY \| WEDNESDAY \| THURSDAY \| FRIDAY \| SATURDAY \| SUNDAY` | True | Required. The day of the week. | 
| timeOfDay | string | True | Required. The time, in 24-hour format. | 
| timeZone | string | False | The time zone, UTC by default, in either the Country/City format, or the UTC offset format. | 

## See also
<a name="brokers-see-also"></a>

For more information about using this API in one of the language-specific AWS SDKs and references, see the following:

### ListBrokers
<a name="ListBrokers-see-also"></a>
+ [AWS Command Line Interface V2](/goto/cli2/mq-2017-11-27/ListBrokers)
+ [AWS SDK for .NET V4](/goto/DotNetSDKV4/mq-2017-11-27/ListBrokers)
+ [AWS SDK for C\$1\$1](/goto/SdkForCpp/mq-2017-11-27/ListBrokers)
+ [AWS SDK for Go v2](/goto/SdkForGoV2/mq-2017-11-27/ListBrokers)
+ [AWS SDK for Java V2](/goto/SdkForJavaV2/mq-2017-11-27/ListBrokers)
+ [AWS SDK for JavaScript V3](/goto/SdkForJavaScriptV3/mq-2017-11-27/ListBrokers)
+ [AWS SDK for Kotlin](/goto/SdkForKotlin/mq-2017-11-27/ListBrokers)
+ [AWS SDK for PHP V3](/goto/SdkForPHPV3/mq-2017-11-27/ListBrokers)
+ [AWS SDK for Python](/goto/boto3/mq-2017-11-27/ListBrokers)
+ [AWS SDK for Ruby V3](/goto/SdkForRubyV3/mq-2017-11-27/ListBrokers)

### CreateBroker
<a name="CreateBroker-see-also"></a>
+ [AWS Command Line Interface V2](/goto/cli2/mq-2017-11-27/CreateBroker)
+ [AWS SDK for .NET V4](/goto/DotNetSDKV4/mq-2017-11-27/CreateBroker)
+ [AWS SDK for C\$1\$1](/goto/SdkForCpp/mq-2017-11-27/CreateBroker)
+ [AWS SDK for Go v2](/goto/SdkForGoV2/mq-2017-11-27/CreateBroker)
+ [AWS SDK for Java V2](/goto/SdkForJavaV2/mq-2017-11-27/CreateBroker)
+ [AWS SDK for JavaScript V3](/goto/SdkForJavaScriptV3/mq-2017-11-27/CreateBroker)
+ [AWS SDK for Kotlin](/goto/SdkForKotlin/mq-2017-11-27/CreateBroker)
+ [AWS SDK for PHP V3](/goto/SdkForPHPV3/mq-2017-11-27/CreateBroker)
+ [AWS SDK for Python](/goto/boto3/mq-2017-11-27/CreateBroker)
+ [AWS SDK for Ruby V3](/goto/SdkForRubyV3/mq-2017-11-27/CreateBroker)

# Brokers broker-id Promote
<a name="brokers-broker-id-promote"></a>

## URI
<a name="brokers-broker-id-promote-url"></a>

`/v1/brokers/broker-id/promote`

## HTTP methods
<a name="brokers-broker-id-promote-http-methods"></a>

### POST
<a name="brokers-broker-id-promotepost"></a>

**Operation ID:** `Promote`

Promotes a data replication replica broker to a primary.


**Path parameters**  

| Name | Type | Required | Description | 
| --- |--- |--- |--- |
| broker-id | String | True | The unique ID that Amazon MQ generates for the broker. | 


**Responses**  

| Status code | Response model | Description | 
| --- |--- |--- |
| 200 |  PromoteOutput | HTTP Status Code 200: OK. | 
| 400 | Error | HTTP Status Code 400: Bad request due to incorrect input. Correct your request and then retry it. | 
| 403 | Error | HTTP Status Code 403: Access forbidden. Correct your credentials and then retry your request. | 
| 404 | Error | HTTP Status Code 404: Resource not found due to incorrect input. Correct your request and then retry it. | 
| 500 | Error | HTTP Status Code 500: Unexpected internal server error. Retrying your request might resolve the issue. | 

### OPTIONS
<a name="brokers-broker-id-promoteoptions"></a>


**Path parameters**  

| Name | Type | Required | Description | 
| --- |--- |--- |--- |
| broker-id | String | True | The unique ID that Amazon MQ generates for the broker. | 


**Responses**  

| Status code | Response model | Description | 
| --- |--- |--- |
| 200 | None | Default response for CORS method | 

## Schemas
<a name="brokers-broker-id-promote-schemas"></a>

### Request bodies
<a name="brokers-broker-id-promote-request-examples"></a>

#### POST schema
<a name="brokers-broker-id-promote-request-body-post-example"></a>

```
{
  "mode": enum
}
```

### Response bodies
<a name="brokers-broker-id-promote-response-examples"></a>

#### PromoteOutput schema
<a name="brokers-broker-id-promote-response-body-promoteoutput-example"></a>

```
{
  "brokerId": "string"
}
```

#### Error schema
<a name="brokers-broker-id-promote-response-body-error-example"></a>

```
{
  "errorAttribute": "string",
  "message": "string"
}
```

## Properties
<a name="brokers-broker-id-promote-properties"></a>

### Error
<a name="brokers-broker-id-promote-model-error"></a>

Returns information about an error.


| Property | Type | Required | Description | 
| --- |--- |--- |--- |
| errorAttribute | string | False | The attribute which caused the error. | 
| message | string | False | The explanation of the error. | 

### PromoteInput
<a name="brokers-broker-id-promote-model-promoteinput"></a>

Creates a Promote request with the properties specified.


| Property | Type | Required | Description | 
| --- |--- |--- |--- |
| mode | [PromoteMode](#brokers-broker-id-promote-model-promotemode) | True | The Promote mode requested. Note: Valid values for the parameter are SWITCHOVER, FAILOVER. | 

### PromoteMode
<a name="brokers-broker-id-promote-model-promotemode"></a>

The Promote mode requested.
+ `SWITCHOVER`
+ `FAILOVER`

### PromoteOutput
<a name="brokers-broker-id-promote-model-promoteoutput"></a>

Returns information about the updated broker.


| Property | Type | Required | Description | 
| --- |--- |--- |--- |
| brokerId | string | False | The unique ID that Amazon MQ generates for the broker. | 

## See also
<a name="brokers-broker-id-promote-see-also"></a>

For more information about using this API in one of the language-specific AWS SDKs and references, see the following:

### Promote
<a name="Promote-see-also"></a>
+ [AWS Command Line Interface V2](/goto/cli2/mq-2017-11-27/Promote)
+ [AWS SDK for .NET V4](/goto/DotNetSDKV4/mq-2017-11-27/Promote)
+ [AWS SDK for C\$1\$1](/goto/SdkForCpp/mq-2017-11-27/Promote)
+ [AWS SDK for Go v2](/goto/SdkForGoV2/mq-2017-11-27/Promote)
+ [AWS SDK for Java V2](/goto/SdkForJavaV2/mq-2017-11-27/Promote)
+ [AWS SDK for JavaScript V3](/goto/SdkForJavaScriptV3/mq-2017-11-27/Promote)
+ [AWS SDK for Kotlin](/goto/SdkForKotlin/mq-2017-11-27/Promote)
+ [AWS SDK for PHP V3](/goto/SdkForPHPV3/mq-2017-11-27/Promote)
+ [AWS SDK for Python](/goto/boto3/mq-2017-11-27/Promote)
+ [AWS SDK for Ruby V3](/goto/SdkForRubyV3/mq-2017-11-27/Promote)

# Configuration
<a name="configurations-configuration-id"></a>

A configuration contains all of the settings for your broker. For more information, see [Amazon MQ for RabbitMQ broker configurations](https://docs.aws.amazon.com//amazon-mq/latest/developer-guide/rabbitmq-broker-configuration-parameters.html) and [Amazon MQ for ActiveMQ broker configurations](https://docs.aws.amazon.com//amazon-mq/latest/developer-guide/amazon-mq-broker-configuration-parameters.html) in the Amazon MQ Developer Guide.

You can create a configuration before creating any brokers. You can then apply the configuration to one or more brokers. 

**Important**  
Making changes to a configuration does not apply the changes to the broker immediately. To apply your changes, you must wait for the next maintenance window or reboot the broker.

## URI
<a name="configurations-configuration-id-url"></a>

`/v1/configurations/configuration-id`

## HTTP methods
<a name="configurations-configuration-id-http-methods"></a>

### GET
<a name="configurations-configuration-idget"></a>

**Operation ID:** `DescribeConfiguration`

Returns information about the specified configuration.


**Path parameters**  

| Name | Type | Required | Description | 
| --- |--- |--- |--- |
| configuration-id | String | True | The unique ID that Amazon MQ generates for the configuration. | 


**Responses**  

| Status code | Response model | Description | 
| --- |--- |--- |
| 200 |  Configuration | HTTP Status Code 200: OK. | 
| 400 | Error | HTTP Status Code 400: Bad request due to incorrect input. Correct your request and then retry it. | 
| 403 | Error | HTTP Status Code 403: Access forbidden. Correct your credentials and then retry your request. | 
| 404 | Error | HTTP Status Code 404: Resource not found due to incorrect input. Correct your request and then retry it. | 
| 500 | Error | HTTP Status Code 500: Unexpected internal server error. Retrying your request might resolve the issue. | 

### PUT
<a name="configurations-configuration-idput"></a>

**Operation ID:** `UpdateConfiguration`

Updates the specified configuration.


**Path parameters**  

| Name | Type | Required | Description | 
| --- |--- |--- |--- |
| configuration-id | String | True | The unique ID that Amazon MQ generates for the configuration. | 


**Responses**  

| Status code | Response model | Description | 
| --- |--- |--- |
| 200 |  UpdateConfigurationOutput | HTTP Status Code 200: OK. | 
| 400 | Error | HTTP Status Code 400: Bad request due to incorrect input. Correct your request and then retry it. | 
| 403 | Error | HTTP Status Code 403: Access forbidden. Correct your credentials and then retry your request. | 
| 404 | Error | HTTP Status Code 404: Resource not found due to incorrect input. Correct your request and then retry it. | 
| 409 | Error | HTTP Status Code 409: Configuration ID is already in use. Remove the configuration from all brokers and retry the request. | 
| 500 | Error | HTTP Status Code 500: Unexpected internal server error. Retrying your request might resolve the issue. | 

### DELETE
<a name="configurations-configuration-iddelete"></a>

**Operation ID:** `DeleteConfiguration`

Deletes the specified configuration.


**Path parameters**  

| Name | Type | Required | Description | 
| --- |--- |--- |--- |
| configuration-id | String | True | The unique ID that Amazon MQ generates for the configuration. | 


**Responses**  

| Status code | Response model | Description | 
| --- |--- |--- |
| 200 |  DeleteConfigurationOutput | HTTP Status Code 200: OK. | 
| 400 | Error | HTTP Status Code 400: Bad request due to incorrect input. Correct your request and then retry it. | 
| 403 | Error | HTTP Status Code 403: Access forbidden. Correct your credentials and then retry your request. | 
| 404 | Error | HTTP Status Code 404: Resource not found due to incorrect input. Correct your request and then retry it. | 
| 409 | Error | HTTP Status Code 409: Configuration ID is already in use. Remove the configuration from all brokers and retry the request. | 
| 500 | Error | HTTP Status Code 500: Unexpected internal server error. Retrying your request might resolve the issue. | 

### OPTIONS
<a name="configurations-configuration-idoptions"></a>


**Path parameters**  

| Name | Type | Required | Description | 
| --- |--- |--- |--- |
| configuration-id | String | True | The unique ID that Amazon MQ generates for the configuration. | 


**Responses**  

| Status code | Response model | Description | 
| --- |--- |--- |
| 200 | None | Default response for CORS method | 

## Schemas
<a name="configurations-configuration-id-schemas"></a>

### Request bodies
<a name="configurations-configuration-id-request-examples"></a>

#### PUT schema
<a name="configurations-configuration-id-request-body-put-example"></a>

```
{
  "data": "string",
  "description": "string"
}
```

### Response bodies
<a name="configurations-configuration-id-response-examples"></a>

#### Configuration schema
<a name="configurations-configuration-id-response-body-configuration-example"></a>

```
{
  "engineVersion": "string",
  "created": "string",
  "authenticationStrategy": enum,
  "name": "string",
  "description": "string",
  "engineType": enum,
  "id": "string",
  "arn": "string",
  "latestRevision": {
    "created": "string",
    "description": "string",
    "revision": integer
  },
  "tags": {
  }
}
```

#### UpdateConfigurationOutput schema
<a name="configurations-configuration-id-response-body-updateconfigurationoutput-example"></a>

```
{
  "created": "string",
  "warnings": [
    {
      "reason": enum,
      "attributeName": "string",
      "elementName": "string"
    }
  ],
  "name": "string",
  "id": "string",
  "arn": "string",
  "latestRevision": {
    "created": "string",
    "description": "string",
    "revision": integer
  }
}
```

#### DeleteConfigurationOutput schema
<a name="configurations-configuration-id-response-body-deleteconfigurationoutput-example"></a>

```
{
  "configurationId": "string"
}
```

#### Error schema
<a name="configurations-configuration-id-response-body-error-example"></a>

```
{
  "errorAttribute": "string",
  "message": "string"
}
```

## Properties
<a name="configurations-configuration-id-properties"></a>

### AuthenticationStrategy
<a name="configurations-configuration-id-model-authenticationstrategy"></a>

Optional. The authentication strategy used to secure the broker. The default is `SIMPLE`.
+ `SIMPLE`
+ `LDAP`
+ `CONFIG_MANAGED`

### Configuration
<a name="configurations-configuration-id-model-configuration"></a>

Returns information about all configurations.


| Property | Type | Required | Description | 
| --- |--- |--- |--- |
| arn | string | True | Required. The ARN of the configuration. | 
| authenticationStrategy | [AuthenticationStrategy](#configurations-configuration-id-model-authenticationstrategy) | True | Optional. The authentication strategy associated with the configuration. The default is `SIMPLE`. | 
| created | stringFormat: date-time | True | Required. The date and time of the configuration revision. | 
| description | string | True | Required. The description of the configuration. | 
| engineType | [EngineType](#configurations-configuration-id-model-enginetype) | True | Required. The type of broker engine. Currently, Amazon MQ supports `ACTIVEMQ` and `RABBITMQ`. | 
| engineVersion | string | True | The broker engine version. Defaults to the latest available version for the specified broker engine type. For a list of supported engine versions, see the [ActiveMQ version management](https://docs.aws.amazon.com//amazon-mq/latest/developer-guide/activemq-version-management.html) and the [RabbitMQ version management](https://docs.aws.amazon.com//amazon-mq/latest/developer-guide/rabbitmq-version-management.html) sections in the Amazon MQ Developer Guide. | 
| id | string | True | Required. The unique ID that Amazon MQ generates for the configuration. | 
| latestRevision | [ConfigurationRevision](#configurations-configuration-id-model-configurationrevision) | True | Required. The latest revision of the configuration. | 
| name | string | True | Required. The name of the configuration. This value can contain only alphanumeric characters, dashes, periods, underscores, and tildes (- . \$1 \$1). This value must be 1-150 characters long. | 
| tags | object | False | The list of all tags associated with this configuration. | 

### ConfigurationRevision
<a name="configurations-configuration-id-model-configurationrevision"></a>

Returns information about the specified configuration revision.


| Property | Type | Required | Description | 
| --- |--- |--- |--- |
| created | stringFormat: date-time | True | Required. The date and time of the configuration revision. | 
| description | string | False | The description of the configuration revision. | 
| revision | integer | True | Required. The revision number of the configuration. | 

### DeleteConfigurationOutput
<a name="configurations-configuration-id-model-deleteconfigurationoutput"></a>

Returns information about the deleted configuration.


| Property | Type | Required | Description | 
| --- |--- |--- |--- |
| configurationId | string | False | The unique ID that Amazon MQ generates for the configuration. | 

### EngineType
<a name="configurations-configuration-id-model-enginetype"></a>

The type of broker engine. Amazon MQ supports ActiveMQ and RabbitMQ.
+ `ACTIVEMQ`
+ `RABBITMQ`

### Error
<a name="configurations-configuration-id-model-error"></a>

Returns information about an error.


| Property | Type | Required | Description | 
| --- |--- |--- |--- |
| errorAttribute | string | False | The attribute which caused the error. | 
| message | string | False | The explanation of the error. | 

### SanitizationWarning
<a name="configurations-configuration-id-model-sanitizationwarning"></a>

Returns information about the configuration element or attribute that was sanitized in the configuration.


| Property | Type | Required | Description | 
| --- |--- |--- |--- |
| attributeName | string | False | The name of the configuration attribute that has been sanitized. | 
| elementName | string | False | The name of the configuration element that has been sanitized. | 
| reason | [SanitizationWarningReason](#configurations-configuration-id-model-sanitizationwarningreason) | True | The reason for which the configuration elements or attributes were sanitized. | 

### SanitizationWarningReason
<a name="configurations-configuration-id-model-sanitizationwarningreason"></a>

The reason for which the configuration elements or attributes were sanitized.
+ `DISALLOWED_ELEMENT_REMOVED`
+ `DISALLOWED_ATTRIBUTE_REMOVED`
+ `INVALID_ATTRIBUTE_VALUE_REMOVED`

### UpdateConfigurationInput
<a name="configurations-configuration-id-model-updateconfigurationinput"></a>

Updates the specified configuration.


| Property | Type | Required | Description | 
| --- |--- |--- |--- |
| data | stringFormat: byte | True | Amazon MQ for Active MQ: The base64-encoded XML configuration. Amazon MQ for RabbitMQ: the base64-encoded Cuttlefish configuration. | 
| description | string | False | The description of the configuration. | 

### UpdateConfigurationOutput
<a name="configurations-configuration-id-model-updateconfigurationoutput"></a>

Returns information about the updated configuration.


| Property | Type | Required | Description | 
| --- |--- |--- |--- |
| arn | string | True | The Amazon Resource Name (ARN) of the configuration. | 
| created | stringFormat: date-time | True | Required. The date and time of the configuration. | 
| id | string | True | The unique ID that Amazon MQ generates for the configuration. | 
| latestRevision | [ConfigurationRevision](#configurations-configuration-id-model-configurationrevision) | False | The latest revision of the configuration. | 
| name | string | True | The name of the configuration. This value can contain only alphanumeric characters, dashes, periods, underscores, and tildes (- . \$1 \$1). This value must be 1-150 characters long. | 
| warnings | Array of type [SanitizationWarning](#configurations-configuration-id-model-sanitizationwarning) | False | The list of the first 20 warnings about the configuration elements or attributes that were sanitized. | 

## See also
<a name="configurations-configuration-id-see-also"></a>

For more information about using this API in one of the language-specific AWS SDKs and references, see the following:

### DescribeConfiguration
<a name="DescribeConfiguration-see-also"></a>
+ [AWS Command Line Interface V2](/goto/cli2/mq-2017-11-27/DescribeConfiguration)
+ [AWS SDK for .NET V4](/goto/DotNetSDKV4/mq-2017-11-27/DescribeConfiguration)
+ [AWS SDK for C\$1\$1](/goto/SdkForCpp/mq-2017-11-27/DescribeConfiguration)
+ [AWS SDK for Go v2](/goto/SdkForGoV2/mq-2017-11-27/DescribeConfiguration)
+ [AWS SDK for Java V2](/goto/SdkForJavaV2/mq-2017-11-27/DescribeConfiguration)
+ [AWS SDK for JavaScript V3](/goto/SdkForJavaScriptV3/mq-2017-11-27/DescribeConfiguration)
+ [AWS SDK for Kotlin](/goto/SdkForKotlin/mq-2017-11-27/DescribeConfiguration)
+ [AWS SDK for PHP V3](/goto/SdkForPHPV3/mq-2017-11-27/DescribeConfiguration)
+ [AWS SDK for Python](/goto/boto3/mq-2017-11-27/DescribeConfiguration)
+ [AWS SDK for Ruby V3](/goto/SdkForRubyV3/mq-2017-11-27/DescribeConfiguration)

### UpdateConfiguration
<a name="UpdateConfiguration-see-also"></a>
+ [AWS Command Line Interface V2](/goto/cli2/mq-2017-11-27/UpdateConfiguration)
+ [AWS SDK for .NET V4](/goto/DotNetSDKV4/mq-2017-11-27/UpdateConfiguration)
+ [AWS SDK for C\$1\$1](/goto/SdkForCpp/mq-2017-11-27/UpdateConfiguration)
+ [AWS SDK for Go v2](/goto/SdkForGoV2/mq-2017-11-27/UpdateConfiguration)
+ [AWS SDK for Java V2](/goto/SdkForJavaV2/mq-2017-11-27/UpdateConfiguration)
+ [AWS SDK for JavaScript V3](/goto/SdkForJavaScriptV3/mq-2017-11-27/UpdateConfiguration)
+ [AWS SDK for Kotlin](/goto/SdkForKotlin/mq-2017-11-27/UpdateConfiguration)
+ [AWS SDK for PHP V3](/goto/SdkForPHPV3/mq-2017-11-27/UpdateConfiguration)
+ [AWS SDK for Python](/goto/boto3/mq-2017-11-27/UpdateConfiguration)
+ [AWS SDK for Ruby V3](/goto/SdkForRubyV3/mq-2017-11-27/UpdateConfiguration)

### DeleteConfiguration
[...]
